#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n, q;

    scanf("%d%d", &n, &q);

    long long d[n], p[n];

    for(int i = 0; i<n; i++) scanf("%lld%lld", &d[i], &p[i]);

    long long h[q];

    for(int i = 0; i<q; i++) scanf("%lld", &h[i]);

    int jeLiNula = 1;

    for(int i = 0; i<n; i++) if(p[i]!=0) jeLiNula = 0;

    if(jeLiNula)
    {
        for(int i = 0; i<q; i++)
        {
            long long out = 0; int c = 0;

            while(out < h[i] && c<n)
            {
                out+=d[c];
                c++;
            }

            if(out>=h[i]) printf("%d\n", c); else printf("-1\n");
        }
        return 0;
    }

    jeLiNula = 1;

    for(int i = 0; i<n; i++) if(d[i]!=0) jeLiNula = 0;

    if(jeLiNula)
    {
        for(int i = 0; i<q; i++)
        {
            long long out = 0; int c = 0;

            while(out < h[i] && c<n)
            {
                out+=(out+p[c]);
                c++;
            }

            if(out>=h[i]) printf("%d\n", c); else printf("-1\n");
        }
        return 0;
    }
    return 0;
}